//+----------------------------------------------------------------------------+
//|                                                              e-TFL_v2.mq4  |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  10.07.2006  Trade From Lines (  ). FreeWare.               |
//|  30.07.2007   :                                          |
//|              - OffsetTL      -     |
//|              - SetRevStopOrd -            |
//|  20.03.2008   MarketWatch.    "Market Watch".  |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV edit by www.expforex.com"
#property link      "http://www.kimiv.ru edit by www.expforex.com"



extern string _P_Trade="----------  ";
int takeprofit;
extern int    TakeProfitup  = 1;         //   
extern int    TakeProfitdw  = 1;         //   
extern int    StopLoss=0;        //   
extern int    Slippage=1;         //  
extern int    NumberOfTry=100;         //   
extern string autolot_=" ";
extern double Lots=0.01;                   //   
extern double LotBalancePcnt=1;          // %        0 -   
//-------    -----------------------------------------+
extern string _P_Expert="----------  ";
extern int    OffsetTL=0;            //   
extern string NameUpLine    = "up";     //   
extern string NameDnLine    = "dw";     //   
extern string NameDnOtstupLine="dwOtstup";     //    
extern bool   BuyFromUp=True;        //    
extern bool   BuyFromDn=False;         //    
extern bool   SetRevStopOrd = False;        //   -
extern bool   ShowComment   = True;         //  
extern bool   MarketWatch   = True;         //    "Market Watch".
extern int    Magic=0;     //   
extern bool   UseSound      = True;         //   
extern string NameFileSound = "expert.wav"; //   

//-------    -------------------------------------+
bool   gbDisabled   = False;           //   
bool   gbNoInit     = False;           //   
color  clOpenBuy    = LightBlue;       //    
color  clOpenSell   = LightCoral;      //    
color  clModifyBuy  = Aqua;            //    
color  clModifySell = Tomato;          //    
color  clCloseBuy   = Blue;            //    
color  clCloseSell  = Red;             //    
double gdUpPrice, gdDnPrice;           //   
double gdPrevUpPrice, gdPrevDnPrice;   //   
double gdPrevAsk, gdPrevBid;           //  

//-------    -----------------------------------------+
#include <stdlib.mqh>        //   4
//+----------------------------------------------------------------------------+
//|                                                                            |
//|  ˨                                                   |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|                                                        |
//+----------------------------------------------------------------------------+
void init()
  {
   gbNoInit=False;
   if(!IsTradeAllowed())
     {
      Message("    \n"+
              "  ");
      gbNoInit=True; return;
     }
   if(!IsLibrariesAllowed())
     {
      Message("    \n"+
              "    ");
      gbNoInit=True; return;
     }
   if(!IsTesting())
     {
      if(IsExpertEnabled()) Message("    ");
      else Message("  \"  \"");
     }
  }

//+----------------------------------------------------------------------------+
//|  expert deinitialization function                                          |
//+----------------------------------------------------------------------------+
void deinit() { if(!IsTesting()) Comment(""); }
//+----------------------------------------------------------------------------+
//|  expert program start function                                             |
//+----------------------------------------------------------------------------+
void start()
  {
   if(gbDisabled)
     {
      Message(" !  !"); return;
     }
   if(gbNoInit)
     {
      Message("   !"); return;
     }
   gdUpPrice=0; gdDnPrice=0;
   if(idPriceLevel() && gdPrevAsk!=0 && gdPrevBid!=0) ManagePositions();

   if(ShowComment)
     {
      string st="";
      if(gdUpPrice==0) st="    \n";
      else
        {
         if(BuyFromUp) st="  ";
         else st="  ";
         st=st+DoubleToStr(gdUpPrice,Digits)+"\n";
         if(SetRevStopOrd)
           {
            if(BuyFromUp) st=st+"SellStop  "+DoubleToStr(gdUpPrice-StopLoss*Point,Digits)+"\n";
            else st=st+"BuyStop  "+DoubleToStr(gdUpPrice+StopLoss*Point,Digits)+"\n";
           }
        }
      if(gdDnPrice==0) st=st+"    ";
      else
        {
         if(BuyFromDn) st=st+"  ";
         else st=st+"  ";
         st=st+DoubleToStr(gdDnPrice,Digits)+"\n";
         if(SetRevStopOrd)
           {
            if(BuyFromDn) st=st+"SellStop  "+DoubleToStr(gdDnPrice-StopLoss*Point,Digits)+"\n";
            else st=st+"BuyStop  "+DoubleToStr(gdDnPrice+StopLoss*Point,Digits)+"\n";
           }
        }
      if(gdDnPrice>0)
        {
         st="Lots="+DoubleToStr(Lots,2)+
            "  StopLoss="+StopLoss+" ."+
            "  TakeProfit="+StopLoss*0.5*TakeProfitdw+" .\n"+st;
        }
      if(gdUpPrice>0)
        {
         st="Lots="+DoubleToStr(Lots,2)+
            "  StopLoss="+StopLoss+" ."+
            "  TakeProfit="+StopLoss*0.5*TakeProfitup+" .\n"+st;
        }

      st="OffsetTL="+OffsetTL+IIFs(MarketWatch,"  MarketWatch","")+"  Magic="+Magic+"\n"+st;
      Comment(st);
     }

   if(gdUpPrice>0) gdPrevUpPrice=gdUpPrice;
   if(gdDnPrice>0) gdPrevDnPrice=gdDnPrice;
   gdPrevAsk=Ask;
   gdPrevBid=Bid;
   StopLoss=(ObjectGetDouble(0,NameUpLine,OBJPROP_PRICE1)-ObjectGetDouble(0,NameDnOtstupLine,OBJPROP_PRICE1))/Point;
  }
//+----------------------------------------------------------------------------+
//|                                                                            |
//|                                                     |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|    : 19.02.2008                                                      |
//|  :                      |
//+----------------------------------------------------------------------------+
void ClosePosBySelect()
  {
   bool   fc;
   color  clClose;
   double ll,pa,pb,pp;
   int    err,it;

   if(OrderType()==OP_BUY || OrderType()==OP_SELL)
     {
      for(it=1; it<=NumberOfTry; it++)
        {
         if(!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
         while(!IsTradeAllowed()) Sleep(5000);
         RefreshRates();
         pa=MarketInfo(OrderSymbol(), MODE_ASK);
         pb=MarketInfo(OrderSymbol(), MODE_BID);
         if(OrderType()==OP_BUY)
           {
            pp=pb; clClose=clCloseBuy;
              } else {
            pp=pa; clClose=clCloseSell;
           }
         ll=OrderLots();
         fc=OrderClose(OrderTicket(), ll, pp, Slippage, clClose);
         if(fc)
           {
            if(UseSound) PlaySound(NameFileSound); break;
              } else {
            err=GetLastError();
            if(err==146) while(IsTradeContextBusy()) Sleep(1000*11);
            Print("Error(",err,") Close ",GetNameOP(OrderType())," ",
                  ErrorDescription(err),", try ",it);
            Print(OrderTicket(),"  Ask=",pa,"  Bid=",pb,"  pp=",pp);
            Print("sy=",OrderSymbol(),"  ll=",ll,"  sl=",OrderStopLoss(),
                  "  tp=",OrderTakeProfit(),"  mn=",OrderMagicNumber());
            Sleep(1000*5);
           }
        }
     }
   else Print("  . Close ",GetNameOP(OrderType()));
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :                                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     Symbol() -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
void ClosePositions(string sy="",int op=-1,int mn=-1)
  {
   int i,k=OrdersTotal();

   if(sy=="0") sy=Symbol();
   for(i=k-1; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op))
           {
            if(OrderType()==OP_BUY || OrderType()==OP_SELL)
              {
               if(mn<0 || OrderMagicNumber()==mn) ClosePosBySelect();
              }
           }
        }
     }
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.03.2008                                                     |
//|   :    .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     Symbol() -  )                 |
//|    op -                    (-1   -  )                    |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )          |
//+----------------------------------------------------------------------------+
bool ExistOrders(string sy="",int op=-1,int mn=-1,datetime ot=0)
  {
   int i,k=OrdersTotal(),ty;

   if(sy=="0") sy=Symbol();
   for(i=0; i<k; i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         ty=OrderType();
         if(ty>1 && ty<6)
           {
            if((OrderSymbol()==sy || sy=="") && (op<0 || ty==op))
              {
               if(mn<0 || OrderMagicNumber()==mn)
                 {
                  if(ot<=OrderOpenTime()) return(True);
                 }
              }
           }
        }
     }
   return(False);
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 06.03.2008                                                     |
//|   :                              |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     Symbol() -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )           |
//+----------------------------------------------------------------------------+
bool ExistPositions(string sy="",int op=-1,int mn=-1,datetime ot=0)
  {
   int i,k=OrdersTotal();

   if(sy=="0") sy=Symbol();
   for(i=0; i<k; i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==sy || sy=="")
           {
            if(OrderType()==OP_BUY || OrderType()==OP_SELL)
              {
               if(op<0 || OrderType()==op)
                 {
                  if(mn<0 || OrderMagicNumber()==mn)
                    {
                     if(ot<=OrderOpenTime()) return(True);
                    }
                 }
              }
           }
        }
     }
   return(False);
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op)
  {
   switch(op)
     {
      case OP_BUY      : return("Buy");
      case OP_SELL     : return("Sell");
      case OP_BUYLIMIT : return("Buy Limit");
      case OP_SELLLIMIT: return("Sell Limit");
      case OP_BUYSTOP  : return("Buy Stop");
      case OP_SELLSTOP : return("Sell Stop");
      default          : return("Unknown Operation");
     }
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    TimeFrame -  ( )      (0 -  )         |
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame=0)
  {
   if(TimeFrame==0) TimeFrame=Period();
   switch(TimeFrame)
     {
      case PERIOD_M1:  return("M1");
      case PERIOD_M5:  return("M5");
      case PERIOD_M15: return("M15");
      case PERIOD_M30: return("M30");
      case PERIOD_H1:  return("H1");
      case PERIOD_H4:  return("H4");
      case PERIOD_D1:  return("Daily");
      case PERIOD_W1:  return("Weekly");
      case PERIOD_MN1: return("Monthly");
      default:           return("UnknownPeriod");
     }
  }
//+----------------------------------------------------------------------------+
//|                                 |
//+----------------------------------------------------------------------------+
bool idPriceLevel()
  {
//   
   if(ObjectFind(NameUpLine)<0)
     {
      gdUpPrice=0;
      gdPrevUpPrice=0;
      Message("   "+NameUpLine);
        } else {
      switch(ObjectType(NameUpLine))
        {
         case OBJ_HLINE: gdUpPrice=ObjectGet(NameUpLine, OBJPROP_PRICE1); break;
         case OBJ_TREND: gdUpPrice=ObjectGetValueByShift(NameUpLine, 0); break;
         default: Message("   "+NameUpLine); break;
        }
      if(gdUpPrice>0) gdUpPrice-=OffsetTL*Point;
     }

//   
   if(ObjectFind(NameDnLine)<0)
     {
      gdDnPrice=0;
      gdPrevDnPrice=0;
      Message("   "+NameDnLine);
        } else {
      switch(ObjectType(NameDnLine))
        {
         case OBJ_HLINE: gdDnPrice=ObjectGet(NameDnLine, OBJPROP_PRICE1); break;
         case OBJ_TREND: gdDnPrice=ObjectGetValueByShift(NameDnLine, 0); break;
         default: Message("   "+NameDnLine); break;
        }
      if(gdDnPrice>0) gdDnPrice+=OffsetTL*Point;
     }

   if(gdUpPrice<gdPrevAsk && gdUpPrice>0)
     {
      gdUpPrice=0;
      Message("  "+NameUpLine+"   ");
     }
   if(gdDnPrice>gdPrevBid && gdDnPrice>0)
     {
      gdDnPrice=0;
      Message("  "+NameDnLine+"   ");
     }

   if(gdUpPrice!=gdPrevUpPrice|| gdDnPrice!=gdPrevDnPrice
      || gdPrevUpPrice==0 || gdPrevDnPrice==0
      || gdUpPrice==0 || gdDnPrice==0) return(False);
   else return(True);
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :        .      |
//+----------------------------------------------------------------------------+
string IIFs(bool condition,string ifTrue,string ifFalse)
  {
   if(condition) return(ifTrue); else return(ifFalse);
  }
//+----------------------------------------------------------------------------+
//|                                                         |
//+----------------------------------------------------------------------------+
void ManagePositions()
  {
   bool   lbBuy=False,lbSell=False;
   double ll;
   ll=GetSizeLotStopLoss(StopLoss);
   double pp,sl=0,tp=0;
   int    ti;

   if((Ask>gdPrevAsk && Ask>=gdUpPrice  &&  BuyFromUp &&  gdUpPrice!=0)
      || (Ask<gdPrevAsk  &&  Ask<=gdDnPrice && BuyFromDn&& gdDnPrice!=0)) lbBuy=True;
   if((Bid>gdPrevBid && Bid>=gdUpPrice && !BuyFromUp && gdUpPrice!=0)
      || (Bid<gdPrevBid  &&  Bid<=gdDnPrice && !BuyFromDn && gdDnPrice!=0)) lbSell=True;

   if(lbBuy)
     {
      takeprofit=StopLoss*0.5*TakeProfitup;

      if(ExistPositions(Symbol(),OP_SELL,Magic)) ClosePositions(Symbol(),OP_SELL,Magic);
      if(!ExistPositions(Symbol(),OP_BUY,Magic))
        {
         if(MarketWatch)
           {
            ti=OpenPosition("",OP_BUY,ll,0,0,Magic);
            if(SelectByTicket(ti))
              {
               if(StopLoss>0) sl=Ask-StopLoss  *Point; else sl=0;
               if(takeprofit>0) tp=Ask+takeprofit*Point; else tp=0;



               ModifyOrder(-1,sl,tp,clModifyBuy);
              }
              } else {
            if(StopLoss>0) sl=Ask-StopLoss  *Point; else sl=0;
            if(TakeProfitup>0) tp=Ask+TakeProfitup*Point; else tp=0;
            OpenPosition("",OP_BUY,ll,sl,tp,Magic);
           }
         if(SetRevStopOrd && sl>0 && !ExistOrders(Symbol(),OP_SELLSTOP,Magic))
           {
            pp=sl;
            sl=pp+StopLoss*Point;
            if(TakeProfitup>0) tp=pp-TakeProfitup*Point; else tp=0;
            SetOrder("",OP_SELLSTOP,ll,pp,sl,tp,Magic);
           }
        }
     }
   if(lbSell)
     {
      takeprofit=StopLoss*0.5*TakeProfitdw;

      if(ExistPositions(Symbol(),OP_BUY,Magic)) ClosePositions(Symbol(),OP_BUY,Magic);
      if(!ExistPositions(Symbol(),OP_SELL,Magic))
        {
         if(MarketWatch)
           {
            ti=OpenPosition("",OP_SELL,ll,0,0,Magic);
            if(SelectByTicket(ti))
              {
               if(StopLoss>0) sl=Bid+StopLoss  *Point; else sl=0;
               if(takeprofit>0) tp=Bid-takeprofit*Point; else tp=0;
               ModifyOrder(-1,sl,tp,clModifySell);
              }
              } else {
            if(StopLoss  >0) sl=Bid+StopLoss  *Point; else sl=0;
            if(takeprofit>0) tp=Bid-takeprofit*Point; else tp=0;
            OpenPosition("",OP_SELL,ll,sl,tp,Magic);
           }
         if(SetRevStopOrd && sl>0 && !ExistOrders(Symbol(),OP_BUYSTOP,Magic))
           {
            pp=sl;
            sl=pp-StopLoss*Point;
            if(takeprofit>0) tp=pp+takeprofit*Point; else tp=0;
            SetOrder("",OP_BUYSTOP,ll,pp,sl,tp,Magic);
           }
        }
     }
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m)
  {
   Comment(m);
   if(StringLen(m)>0) Print(m);
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :     .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -   ,                              |
//|    sl -                                                 |
//|    tp -                                                 |
//|    cl -                                                                |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1,double sl=0,double tp=0,color cl=CLR_NONE)
  {
   bool   fm;
   double pa=MarketInfo(OrderSymbol(), MODE_ASK);
   double pb=MarketInfo(OrderSymbol(), MODE_BID);
   double op,os,ot;
   int    dg,err,it;

   if(pp<=0) pp=OrderOpenPrice();
   if(sl<0) sl=OrderStopLoss();
   if(tp<0) tp=OrderTakeProfit();

   dg=MarketInfo(OrderSymbol(), MODE_DIGITS);
   pp=NormalizeDouble(pp, dg);
   sl=NormalizeDouble(sl, dg);
   tp=NormalizeDouble(tp, dg);
   op=NormalizeDouble(OrderOpenPrice() , dg);
   os=NormalizeDouble(OrderStopLoss()  , dg);
   ot=NormalizeDouble(OrderTakeProfit(), dg);

   if(pp!=op || sl!=os || tp!=ot)
     {
      for(it=1; it<=NumberOfTry; it++)
        {
         if(!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
         while(!IsTradeAllowed()) Sleep(5000);
         RefreshRates();
         fm=OrderModify(OrderTicket(),pp,sl,tp,0,cl);
         if(fm)
           {
            if(UseSound) PlaySound(NameFileSound); break;
              } else {
            err=GetLastError();
            Print("Error(",err,") modifying order: ",ErrorDescription(err),", try ",it);
            Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
                  "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
            Sleep(1000*10);
           }
        }
     }
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 06.03.2008                                                     |
//|   :      .                       |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""  Symbol() -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//+----------------------------------------------------------------------------+
int OpenPosition(string sy,int op,double ll,double sl=0,double tp=0,int mn=0)
  {
   color    clOpen;
   datetime ot;
   double   pp,pa,pb;
   int      dg,err,it,ticket=0;
   string   lsComm=WindowExpertName()+" "+GetNameTF(Period());

   if(sy=="" || sy=="0") sy=Symbol();
   if(op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
   for(it=1; it<=NumberOfTry; it++)
     {
      if(!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while(!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      dg=MarketInfo(sy, MODE_DIGITS);
      pa=MarketInfo(sy, MODE_ASK);
      pb=MarketInfo(sy, MODE_BID);
      if(op==OP_BUY) pp=pa; else pp=pb;
      pp=NormalizeDouble(pp, dg);
      ot=TimeCurrent();
      ticket=OrderSend(sy,op,ll,pp,Slippage,sl,tp,lsComm,mn,0,clOpen);
      if(ticket>0)
        {
         if(UseSound) PlaySound(NameFileSound); break;
           } else {
         err=GetLastError();
         if(err==128 || err==142 || err==143)
           {
            Sleep(1000*66.666);
            if(ExistPositions(sy,op,mn,ot))
              {
               if(UseSound) PlaySound(NameFileSound); break;
              }
           }
         //    
         Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
         Print("Ask=",pa," Bid=",pb," sy=",sy," ll=",ll," op=",GetNameOP(op),
               " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
         if(pa==0 && pb==0) Message("      "+sy);
         //   
         if(err==2 || err==64 || err==65 || err==133)
           {
            gbDisabled=True; break;
           }
         //  
         if(err==4 || err==131 || err==132)
           {
            Sleep(1000*300); break;
           }
         if(err==140 || err==148 || err==4110 || err==4111) break;
         if(err==141) Sleep(1000*100);
         if(err==145) Sleep(1000*17);
         if(err==146) while(IsTradeContextBusy()) Sleep(1000*11);
         if(err!=135) Sleep(1000*7.7);
        }
     }
   return(ticket);
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 20.04.2007                                                     |
//|   :           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    ti -  ,                                               |
//|    sy -     (""   -  ,                   |
//|                                     Symbol() -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
bool SelectByTicket(int ti,string sy="",int op=-1,int mn=-1)
  {
   int i,k=OrdersTotal();

   if(sy=="0") sy=Symbol();
   for(i=0; i<k; i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op))
           {
            if((mn<0 || OrderMagicNumber()==mn) && OrderTicket()==ti) return(True);
           }
        }
     }
   return(False);
  }
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 13.03.2008                                                     |
//|   :  .                                              |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (Symbol()  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    pp -                                                                |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - Magic Number                                                       |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void SetOrder(string sy,int op,double ll,double pp,
              double sl=0,double tp=0,int mn=0,datetime ex=0)
  {
   color    clOpen;
   datetime ot;
   double   pa,pb,mp;
   int      err,it,ticket,msl;
   string   lsComm=WindowExpertName()+" "+GetNameTF(Period());

   if(sy=="" || sy=="0") sy=Symbol();
   msl=MarketInfo(sy,MODE_STOPLEVEL);
   if(op==OP_BUYLIMIT || op==OP_BUYSTOP) clOpen=clOpenBuy; else clOpen=clOpenSell;
   if(ex>0 && ex<TimeCurrent()) ex=0;
   for(it=1; it<=NumberOfTry; it++)
     {
      if(!IsTesting() && (!IsExpertEnabled() || IsStopped()))
        {
         Print("SetOrder():   ");
         break;
        }
      while(!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      ot=TimeCurrent();
      ticket=OrderSend(sy,op,ll,pp,Slippage,sl,tp,lsComm,mn,ex,clOpen);
      if(ticket>0)
        {
         if(UseSound) PlaySound(NameFileSound); break;
           } else {
         err=GetLastError();
         if(err==128 || err==142 || err==143)
           {
            Sleep(1000*66);
            if(ExistOrders(sy,op,mn,ot))
              {
               if(UseSound) PlaySound(NameFileSound); break;
              }
            Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
            continue;
           }
         mp=MarketInfo(sy, MODE_POINT);
         pa=MarketInfo(sy, MODE_ASK);
         pb=MarketInfo(sy, MODE_BID);
         if(pa==0 && pb==0) Message("SetOrder():       "+sy);
         Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
         Print("Ask=",pa,"  Bid=",pb,"  sy=",sy,"  ll=",ll,"  op=",GetNameOP(op),
               "  pp=",pp,"  sl=",sl,"  tp=",tp,"  mn=",mn);
         //  
         if(err==130)
           {
            switch(op)
              {
               case OP_BUYLIMIT:
                  if(pp>pa-msl*mp) pp=pa-msl*mp;
                  if(sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
                  if(tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
                  break;
               case OP_BUYSTOP:
                  if(pp<pa+(msl+1)*mp) pp=pa+(msl+1)*mp;
                  if(sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
                  if(tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
                  break;
               case OP_SELLLIMIT:
                  if(pp<pb+msl*mp) pp=pb+msl*mp;
                  if(sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
                  if(tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
                  break;
               case OP_SELLSTOP:
                  if(pp>pb-msl*mp) pp=pb-msl*mp;
                  if(sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
                  if(tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
                  break;
              }
            Print("SetOrder():   ");
           }
         //   
         if(err==2 || err==64 || err==65 || err==133)
           {
            gbDisabled=True; break;
           }
         //  
         if(err==4 || err==131 || err==132)
           {
            Sleep(1000*300); break;
           }
         //    (8)     (141)
         if(err==8 || err==141) Sleep(1000*100);
         if(err==139 || err==140 || err==148) break;
         //    
         if(err==146) while(IsTradeContextBusy()) Sleep(1000*11);
         //   
         if(err==147)
           {
            ex=0; continue;
           }
         if(err!=135 && err!=138) Sleep(1000*7.7);
        }
     }
  }
//+----------------------------------------------------------------------------+
double lastlot;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


double GetSizeLotStopLoss(double StopLosssd=1) //   , 
  {
   string Autor="     : www.expforex.com";
   string Valdepo=AccountCurrency();
//     , 
   double MinLots;
   int lotdig;
   if(MarketInfo(Symbol(),MODE_LOTSTEP)==0.01)lotdig=2; else lotdig=1;
   double Free=AccountBalance();
   double LotVal=MarketInfo(Symbol(),MODE_TICKVALUE);// 1   1 
   double Min_Lot =MarketInfo(Symbol(),MODE_MINLOT);
   double Max_Lot =MarketInfo(Symbol(),MODE_MAXLOT);
   double Step=MarketInfo(Symbol(),MODE_LOTSTEP);
   double Lot;if(LotBalancePcnt!=0 && StopLosssd!=0)Lot=MathFloor((Free*LotBalancePcnt/100)/(StopLosssd*LotVal)/Step)*Step;
   if(LotBalancePcnt==0 || StopLosssd==0)Lot=Lots;
   MinLots=MarketInfo(Symbol(),MODE_MINLOT);

   if(Lot<MinLots) Lot=MinLots;

   return(NormalizeDouble(Lot,lotdig));
  }
//+------------------------------------------------------------------+
